# -*- coding: utf_8 -*-
import direct.directbase.DirectStart
from pandac.PandaModules import *
from direct.task import Task
from direct.actor import Actor
from direct.interval.IntervalGlobal import *
from direct.showbase import DirectObject   
from pandac.PandaModules import Vec3
import sys,math

#from direct.showbase.DirectObject import DirectObject

from direct.gui.OnscreenText import OnscreenText
from direct.gui.DirectGui import *

#zagruzka modeli okrujeniya
environ = loader.loadModel("models/world_")
environ.reparentTo(render)
environ.setScale(2,2,2) 
environ.setPos(0,0,-20)

#zagruzka moddeli i animacii
pandaActor = Actor.Actor("Pokatigoroshek_Statik",{"walk":"Pokatigoroshek_Statik-anim1"})
pandaActor.setScale(2,2,2) 
pandaActor.setPos(0,0,-4)
#pandaActor.reparentTo(render)
avatar = render.attachNewNode('avatar')  ## avatar Это пучтышка -Самый главный в иерархии ###!!!attachNewNode - метод класса NodePath, добавляющий новый нод 
pandaActor.reparentTo(avatar) ## pandaActor  крепиться к avatar
avatar.setPos(0,0,0)

camCenter = render.attachNewNode('camCenter') 
camCenter.reparentTo(avatar) ##  camCenter крепим к avatar
camCenter.setZ(2)
base.camera.reparentTo(camCenter) ## КАмеру крепим к КамероЦентру


base.camera.lookAt(camCenter)


base.disableMouse()# Убираем базовое управление  мышью
#nash klass dlya upravleniya akterom
def point_dist(p1,p2):
    return math.sqrt((p1[0]-p2[0])**2+(p1[1]-p2[1])**2+(p1[2]-p2[2])**2)
class KeyHandler(DirectObject.DirectObject):
      def __init__(self):
            self.keyMap = {"left":0, "right":0, "vpered":0, "cam-left":0, "cam-right":0, "nazad":0,"jump":0}### ХЗ что это
                      
            base.cTrav = CollisionTraverser()#предположительно общее обьявление колизий
##### Сфера
            cn = CollisionNode('')########            
            cn.addSolid(CollisionSphere(0,0,-0.5,1.5))###Сфера используеться для проверки колизий сквозь горизонтальные обьекты (не terrain)
            solid = avatar.attachNewNode(cn)## attachNewNode - метод класса NodePath, добавляющий новый нод (cn имя нода)
           # solid.setZ(-1)
            
            self.pusher = CollisionHandlerPusher()        
            base.cTrav.addCollider(solid,self.pusher)
            self.pusher.addCollider(solid,avatar, base.drive.node())
######## Конец Сферы
            base.cTrav.showCollisions(render)### Просто показует все Колизии и не зависит ни от кого !!!!

            
            ray = CollisionRay()# главный луч ## изходит НЕ из сферы
            ray.setOrigin(0,0,-0.2)#мещение главного луча ####### не понятно зачем
            ray.setDirection(0,0,-1) # направление главного луча вниз
            cn = CollisionNode('')########
            cn.addSolid(ray)
            #cn.setFromCollideMask(BitMask32.bit(0))
            cn.setIntoCollideMask(BitMask32.allOff())
            solid = avatar.attachNewNode(cn)
            self.avatarGroundHandler = CollisionHandlerQueue()      ###
            base.cTrav.addCollider(solid,self.avatarGroundHandler)  ###
            
             
            #CamRay1
            camRay = CollisionRay()
            camRay.setOrigin(0,-0.2,0)
            camRay.setDirection(0,-1,0)
            cn =CollisionNode('camRay1')
            cn.addSolid(camRay)
            cn.setIntoCollideMask(BitMask32.allOff())
            solid = camCenter.attachNewNode(cn)
            solid.setX(-0.5)
            #solid.show()
            self.avatarCamHandler1 = CollisionHandlerQueue()             ###
            base.cTrav.addCollider(solid, self.avatarCamHandler1)
##            
##            #CamRay2
##            camRay = CollisionRay()
##            camRay.setOrigin(0,-0.2,0)
##            camRay.setDirection(0,-1,0)
##            cn =CollisionNode('camRay2')
##            cn.addSolid(camRay)
##            cn.setIntoCollideMask(BitMask32.allOff())
##            solid = camCenter.attachNewNode(cn)
##            solid.setX(0.5)
##            #solid.show()
##            self.avatarCamHandler1 = CollisionHandlerQueue()
##            base.cTrav.addCollider(solid, self.avatarCamHandler1)
        
        
         #   base.cTrav.addCollider(solid, self.avatarCamHandler1)
        
            ############################################# Конец Colision

            #peremennye skorosti peremescheniya i povorota
            self.speed=0
            self.ws=0
            self.ad=0
            self.speedX=0
            self.speedY=0
            #registriruem sobytiya reagiruyuschie na klaviaturu
            #Zamechanie: modifikator masshtaba, primenennyy k nodu   
            #tak je deystvuet i na peremescheniya, poetomu skorost'   
            #stavim dovol'no bol'shuyu
            self.accept("escape", sys.exit)
            self.accept("a", self.setKey, ["left",1])
            self.accept("d", self.setKey, ["right",1])
            self.accept("w", self.setKey, ["vpered",1])
            self.accept("s", self.setKey, ["nazad",1])
            self.accept("a-up", self.setKey, ["left",0])
            self.accept("d-up", self.setKey, ["right",0])
            self.accept("w-up", self.setKey, ["vpered",0])
            self.accept("s-up", self.setKey, ["nazad",0])
            self.accept("space",self.setKey,["jump",1])
            self.accept("space-up",self.setKey,["jump",0])

            #registriruem zadachu peremescheniya aktera         

            #base.camera.lookAt(0,30,0)# Указываем куда смотреть камере
            #self.dragging=False
            self.target=Vec3()
            self.camDist=40  
            ###     
            self.NX=0   ## эта переменная запоминает смещение курсора (счетчик) по Х
            self.Av_NX=0## эта переменная запоминает смещение курсора (счетчик) по Х специально для главной Пустышки Avatar
            self.NY=0   ## эта переменная запоминает смещение курсора (счетчик) по Y
            self.sens=0.3
            self.jump=0
            ###                   
            taskMgr.add(self.moveTask,"moveTask") #вызываем функцию moveTask 
            taskMgr.add(self.jumpUpdate, 'jump-task')        
           
      #procedura, ustanavlivayuschaya skorost' peremescheniya
      #i zapuskayuschaya animaciyu, esli nujno      
      #procedura, ustanavlivayuschaya skorost' povorota         
      def setKey(self, key, value):
        self.keyMap[key] = value
       
        if (self.keyMap["vpered"]!=0) or (self.keyMap["left"]!=0) or (self.keyMap["right"]!=0)or (self.keyMap["nazad"]!=0):          
            pandaActor.loop("walk")      
            pandaActor.getAnimControl("walk").setPlayRate(1)                 
        else:
            pandaActor.stop()   
      #sobstvenno procedura obrabotki peremescheniya nashego aktera
      def moveTask(self,task):## В ЭТwОЙ ЧАСТИ ПЕРЕМЕЩЕНИЕ ПЕРСОНАЖА  И ПОВОРОТ КАМЕРЫ 
        ##  Перемещение
        if (self.keyMap["vpered"]!=0):            
            avatar.setPos(avatar,0,-0.5,0)      
        if (self.keyMap["nazad"]!=0):            
            avatar.setPos(avatar,0,0.5,0)        
        if (self.keyMap["right"]!=0):
            avatar.setPos(avatar,-0.5,0,0)
        if (self.keyMap["left"]!=0):
            avatar.setPos(avatar,0.5,0,0)

        ### Поворот
            
        Xc=base.win.getXSize()/2-base.win.getPointer(0).getX()## смещение курсора
        Yc=base.win.getYSize()/2-base.win.getPointer(0).getY()

        base.win.movePointer(0,base.win.getXSize()/2,base.win.getYSize()/2)#переводим курсов в центр
        
        base.camera.setY(-25)## отодвигаем камеру от центра 
##        camCenter.setZ(2)## устанавливаем camCenter(к которому прикреплена камера) выше центра
      #  if base.mouseWatcherNode.hasMouse():# если мышь начинает двигаться тогда :              
        self.NX=Xc+self.NX ## эта переменная запоминает смещение курсора (счетчик) по Х для camCenter
        self.Av_NX=Xc+self.Av_NX## эта переменная запоминает смещение курсора (счетчик) по Х специально для главной Пустышки Avatar
        self.NY=Yc+self.NY ## эта переменная запоминает смещение курсора (счетчик) по Y для camCenter
        camCenter.setH(base.camera.getX()+self.NX*self.sens+180) #поворачиваем avatar к которому  прикреплена наш camCenterа потом камера
        ug_pov=camCenter.getH()## Запоминаем угол поворота camCenter
        
        if self.keyMap["vpered"]!=0 or self.keyMap["nazad"]!=0 or (self.keyMap["right"]!=0) or (self.keyMap["left"]!=0) : # Если нажимаем Вперед или назад тогда : 
            self.NX=0 #смещение для camCenter обнуляем 
            camCenter.setH(camCenter.getH()-ug_pov+180) #  camCenter возвращаем в начальное значение           
            avatar.setH(base.camera.getX()+self.Av_NX*self.sens) # avatar поворачиваем в куда нужно
       
        camCenter.setP(base.camera.getY()+self.NY*self.sens) #поворачиваем ВЕРТИКАЛЬНО camCenter к которой прикреплена наша камера 
        ############# Проверка КАМЕРЫ  на колизии
        #near_point=Point3(0,0,0)
        if (self.avatarCamHandler1.getNumEntries()>0):
             
            self.avatarCamHandler1.sortEntries() 
            entry = self.avatarCamHandler1.getEntry(0) 
            near_point = entry.getSurfacePoint(render)
        
            p1=avatar.getX(),avatar.getY(),avatar.getZ()
            p2=near_point.getX(),near_point.getY(),near_point.getZ()
       
            dist=point_dist(p1,p2)
        
            if (dist<25): #проверка dist--- расстояние камеры от центра
                base.camera.setY(-dist)   
##            else:            
##                base.camera.setY(-25)
        #############################
        return task.cont
    #################################################################
      def jumpUpdate(self,task):
        """ this task simulates gravity and makes the player jump """
        # get the highest Z from the down casting ray
        highestZ = -100 # некое знакчение к которому потом стремиться
        #for n in range(self.pusher.getNumEntries()):
            #se=self.pusher.getEntry(n)
        for i in range(self.avatarGroundHandler.getNumEntries()):
            entry = self.avatarGroundHandler.getEntry(i)
            z = entry.getSurfacePoint(render).getZ()
            if z > highestZ and entry.getIntoNode().getName() == "terrain":
                highestZ = z
               
        # gravity effects and jumps
        
        ####avatar.setZ(avatar.getZ()+self.jump*globalClock.getDt())
        avatar.setZ(avatar.getZ()+self.jump)
        ##### globalClock.getDt() узнаёт время,прошедшее с момента рендера последнего кадра,оно используется для организации равномерного движения объекта 
        self.jump = self.jump -2  #6*globalClock.getDt()
        
        if highestZ > avatar.getZ()-6.4:           
            self.jump = 0
            avatar.setZ(highestZ+6.4)
            if (self.keyMap["jump"]!=0):
                self.jump = 10
        return task.cont
#sozdaem klass, otvechayuschiy za upravlenie
KeyHandler()
#i zapuskaem osnovnoy cikl
run()    